Description

On deleting a class interface availible via the drop down menu on the nav bar the system bombs out with the following:

Warning!

ERROR: update or delete on table "puppetclasses" violates foreign key constraint "environment_classes_puppetclass_id_fk" on table

"environment_classes" DETAIL: Key (id)=(8) is still referenced from table "environment_classes".

Stack Trace:

PGError

ERROR: update or delete on table "puppetclasses" violates foreign key constraint "environment_classes_puppetclass_id_fk" on table

"environment_classes" DETAIL: Key (id)=(8) is still referenced from table "environment_classes".

app/controllers/puppetclasses_controller.rb:42:in `destroy'

app/models/concerns/foreman/thread_session.rb:33:in `clear_thread'

lib/middleware/catch_json_parse_errors.rb:9:in `call'

Related issues:

Has duplicate Foreman - Bug #5225: Deleting a puppet-class: Mysql2::Error: Ca... Duplicate 04/17/2014

Has duplicate Foreman - Bug #5213: Error during delete a puppet class Duplicate 04/16/2014

Has duplicate Foreman - Bug #6045: deleting a class fails Duplicate 06/03/2014

Has duplicate Foreman - Bug #7255: unable to delete puppet class Duplicate 08/25/2014

History

#1 - 02/21/2014 04:53 PM - Bryce Camp

- File foreman_class_removal_error.jpg added

I am experiencing the same issue

#2 - 02/24/2014 08:39 AM - Dominic Cleal

- Category set to Database

#3 - 04/17/2014 12:08 PM - Marek Hulán

- Has duplicate Bug #5225: Deleting a puppet-class: Mysql2::Error: Cannot delete or update a parent row: a foreign key constraint fails added

#4 - 04/22/2014 09:11 AM - Dominic Cleal

- Has duplicate Bug #5213: Error during delete a puppet class added

#5 - 05/14/2014 01:12 PM - Eric Goedtel

Its not explicitly stated here but you can work around this by removing the module from the applicable environment directory on the puppet master

Foreman is interacting with.

#6 - 06/04/2014 11:20 AM - Dominic Cleal

- Has duplicate Bug #6045: deleting a class fails added
#7 - 08/06/2014 07:39 AM - Yama Kasi

I'm also facing this problem.

Even removing the Puppet module doesn't fix this at the moment. I'm stuck with some classes that are not there but FM thinks they are (in use).

Any ideas ?

#8 - 08/06/2014 07:44 AM - Yama Kasi

I'm on 1.5.2 at the moment.

#9 - 08/06/2014 08:03 AM - Yama Kasi

OK, update... fixed. It seems that Foreman is importing "conflicting" classes form other modules with the same name (as you copy them over and edit

them half)

#10 - 08/06/2014 11:07 AM - Jem Sebban

Hello,

I'm also running Centos 6.5 and have a similar issue while trying to delete classes from foreman web UI.

Puppet version is latest from puppetlabs repo - 3.6.2-1

Foreman version is 1.5.2-1, also current.

Only "exotic" aspect of my setup is I recently updated puppet from 2.7.x (EPEL) to 3.6.x (puppetlabs)

What kind of update did fix this for you Yama Kasi ? Is the UI delete button now working as expected ?

I was able to delete classes by manually removing them form their environment directory but I would like to be able to do that from the UI to ease

collaboration with my colleagues.

#11 - 08/25/2014 05:54 PM - Anonymous

- Has duplicate Bug #7255: unable to delete puppet class added

#12 - 09/29/2014 04:18 AM - Dominic Cleal

- Bugzilla link set to 1147379

#13 - 03/04/2015 10:46 AM - Tom Caspy

this is quite odd, as the relation has dependent: true on it. How can we reproduce this?

#14 - 05/20/2017 05:32 AM - Anonymous

- Status changed from New to Resolved

the linked BZ got closed
